# AppClassNet: A commercial-grade dataset for application identification research
This repository contains the PyTorch and Scikit-Learn model implementations to replicate the baseline models.  

## Data Requirements

Running the baseline assumes you have downloaded and extracted the AppClassNet dataset in the `data/` folder.
	
## Code Requirements

Models have been implemented in Python 3.6 with the following packages:
* Numpy 
* Pandas
* PyTorch
* Scikit-Learn
* TorchsummaryX
* Torchvision
* PyYAML

## Installation Procedure
Create a new conda environment
```
conda create -n appclassnet python=3.6
```

Activate the new environment
```
conda activate appclassnet
```

Install required packages
```
pip install numpy pandas torch scikit-learn torchsummaryx torchvision pyyaml
```

## Usage

After ensuring the AppClassNet dataset is accessible in the `data/` folder, you can trigger training and inference by running `main.py`, where choice of the model and hyperparameters is specified via a YAML configuration file, as in:

```
python main.py --config configuration/config.yml
```

If you did not alter the default `configuration/config.yml`, the above command employs a simple decision tree: the expected output from the above command is as follows:

```
Train set size:  (4347270, 20)
Validation set size:  (482489, 20)
Test set size:  (4830012, 20)
Start Training
              Dataset Architecture     Train_Size  Depth  Leaves  Accuracy_Train  Accuracy_Validation  Accuracy_Test
0  AppClassNet/top200           dt  (4347270, 20)     78  551982        0.999996             0.813248       0.868584
```

